<?php
/* vim: set et ts=4 sw=4 sts=4 ai: */
// +----------------------------------------------------------------------+
// | Admin functions                                                      |
// +----------------------------------------------------------------------+
// | @version $Revision: 1.6 $
// +----------------------------------------------------------------------+

// Only admins are allowed here. Admins are defined as those whose tripcode
// is listed in a comma-separated list in ADMINS, defined in conf.php
//
// If the tripcode cookie does not contain an admin tripcode, present a
// "login" form that allows them to set a new tripcode.

$is_admin = false;
$tripcodes = explode(",",ADMINS);

$tmpl = new HTML_Template_IT(TEMPLATE_DIR);
$tmpl->loadTemplateFile("admin.tmpl");

if($_POST) {
    $tripcode = tripcode($_POST["tripcode"]);
    setcookie("tripcode",$_POST["tripcode"],COOKIE_EXPIRES);
    // Redirect here to avoid the page being in a posted state
    header("Location: " . ABSOLUTE_ROOT . "/" . $path);
} else {
    $tripcode = tripcode($_COOKIE["tripcode"]);
}
    
if(in_array($tripcode,$tripcodes)) {
    $is_admin = true;
} else {
    $tmpl->setVariable("failed_tripcode",$tripcode);
}

if(!$is_admin) {
    $tmpl->touchBlock("login_form");
} else {

    //----- IS ADMIN

    // Category administration
    $categories = getCategories();
    if($categories === false) {
        $tmpl->touchBlock("no_categories");
    } else {
        foreach($categories as $row) {
            $tmpl->setCurrentBlock("category");
            $tmpl->setVariable(array(
                "id"        => $row["id"],
                "category"  => stripslashes($row["category"]),
                "abbr"      => stripslashes($row["abbr"]),
                "description"   => htmlspecialchars(stripslashes($row["description"])),
                "sort"      => $row["sort"] ? $row["sort"] : "bump",
            ));
            $tmpl->setVariable("ROOT",ROOT);
            $tmpl->parseCurrentBlock();
        }
    }
    
    $tmpl->setVariable(array(
        "add_root"  => ROOT,
        "cache_root"    => ROOT,
    ));
}
$tmpl->show();
?>
