<?php
/* vim: set et ts=4 sw=4 sts=4 ai: */
// +----------------------------------------------------------------------+
// | Modify form
// +----------------------------------------------------------------------+
// | @version $Revision: 1.6 $
// +----------------------------------------------------------------------+

if(!$page) { exit; }

$id = $_REQUEST["id"];
if(!is_numeric($id)) { $page->fail($ERRORS["unknownrequest"]); }
$image = getImage($id);
if($image === false) {
	$page->fail($ERRORS["queryfail"]);
}
$thumb = getImageUrl($id,$image["file"],true);
$title = $image["title"] ? $image["title"] : $STRINGS["untitled"];

// ADMINS can edit comments
$tripcode = tripcode($_COOKIE["tripcode"]);
$tripcodes = explode(",",ADMINS);
$is_admin = in_array($tripcode,$tripcodes) ? true : false;

if($_POST) {
    if ($image["tripcode"] !== tripcode($_POST["tripcode"])) {
        $page->fail($ERRORS["tripcodefail"]);
    }

    //----- A category is required
    $categories = false;
    if(FEATURE_MULTIPLE_CATEGORY===true && is_array($_POST["categories"]) && count($_POST["categories"])>0) {
        $categories = "/" . implode("/",$_POST["categories"]) . "/";

    } else if($_POST["categories"]){
        $categories = "/" . $_POST["categories"] . "/";
    }
    if(!$categories) {
        $page->fail($ERRORS["categoryrequired"]);
    }

    // Keywords - not required
    $keywords = $_POST["keywords"];

    // Title - not required
    $title = $_POST["title"];

    $comment = $is_admin ? $_POST["comment"] : false;

    if($result = modifyImage($id,$title,$categories,$keywords,$comment)) {
        echo $STRINGS["modifythanks"];
        echo JS_AUTO_CLOSE;
    } else {
        $page->fail($ERRORS["queryfail"]);
    }

} else {

    $tmpl = new HTML_Template_IT(TEMPLATE_DIR);
    $tmpl->loadTemplateFile("modify.tmpl");

    //----- Current categories...
    $c = ereg_replace("^/(.+)/$","\\1",$image["category"]);
    $c = explode("/",$c);
    $categories = getCategories();
    foreach($categories as $row) {
        $tmpl->setCurrentBlock("categories");
        $vars = array(
            "category_type"     => FEATURE_MULTIPLE_CATEGORY ? "checkbox" : "radio",
            "category_name"     => FEATURE_MULTIPLE_CATEGORY ? "categories[]" : "categories",
            "category_value"    => $row["abbr"],
            "label"     => $row["category"],
        );
        if(in_array($row["abbr"],$c)) {
            $vars["checked"] = 'checked="true"';
        }
        $tmpl->setVariable($vars);
        $tmpl->parseCurrentBlock();
    }

    $vars = array(
        "id"    => $image["id"],
        "thumb" => $thumb,
        "title" => htmlspecialchars(stripslashes($title)),
        "name" => htmlspecialchars(stripslashes($image["name"])),
        "keywords" => htmlspecialchars(stripslashes($image["keywords"])),
    );

    if($is_admin) {
        $vars["comment"] = htmlspecialchars(stripslashes($image["comment"]));
    }

    $tmpl->setVariable($vars);
    $tmpl->show();
    return;
}
?>
