<?php
/* vim: set et ts=4 sw=4 sts=4 ai: */
// +----------------------------------------------------------------------+
// | Site stats display                                                   |
// +----------------------------------------------------------------------+
// | @version $Revision: 1.5 $
// +----------------------------------------------------------------------+

//----- Sanity check - this file shouldn't be referenced directly
//		and htaccess should be configured to disallow access to this dir
if(!$page) { exit; }

$tmpl = new HTML_Template_IT(TEMPLATE_DIR);
$tmpl->loadTemplateFile("stats.tmpl",true,true);

if(!$categories = getCategories()) {
    $page->fail($ERRORS["queryfail"]);
}
if(!$stats = getStats()) {
    $page->fail($ERRORS["queryfail"]);
}

$totals = array();
$totals["category"] = "Totals";
foreach($categories as $row) {
    $vars = array();
	$vars["category"] = "/" . $row["abbr"];
    foreach(array("total_posts","num_threads","num_images","total_size","num_views") as $label) {
        $vars[$label] = $stats[$label][$row["abbr"]] ? $stats[$label][$row["abbr"]] : "0";
        if($label == "total_size") {
            $vars[$label] = sprintf("%.2f",((int)$vars[$label])/1048576);
        }
        $totals[$label] += (int) $vars[$label];
    }
    $vars["replies_per_thread"] = $vars["num_threads"] > 0 ?
        sprintf("%.2f",($vars["total_posts"] - $vars["num_threads"])/$vars["num_threads"]) :
        0;
    $vars["images_per_thread"] = $vars["num_threads"] > 0 ?
        sprintf("%.2f",($vars["num_images"]/$vars["num_threads"])) :
        0;
    $vars["average_file_size"] = $vars["num_images"] > 0 ?
        sprintf("%.2f",$vars["total_size"] / $vars["num_images"] * 1024):
        0;
    $vars["views_per_image"] = $vars["num_images"] > 0 ?
        sprintf("%.2f",($vars["num_views"]/$vars["num_images"])) :
        0;


    $tmpl->setCurrentBlock("stats_row");
    $tmpl->setVariable($vars);
    $tmpl->parseCurrentBlock();
}
    $totals["replies_per_thread"] = $totals["num_threads"] > 0 ?
        sprintf("%.2f",($totals["total_posts"] - $totals["num_threads"])/$totals["num_threads"]) :
        0;
    $totals["images_per_thread"] = $totals["num_threads"] > 0 ?
        sprintf("%.2f",($totals["num_images"]/$totals["num_threads"])) :
        0;
    $totals["average_file_size"] = $totals["num_images"] > 0 ?
        sprintf("%.2f",$totals["total_size"] / $totals["num_images"] * 1024):
        0;
    $totals["views_per_image"] = $totals["num_images"] > 0 ?
        sprintf("%.2f",($totals["num_views"]/$totals["num_images"])) :
        0;

$tmpl->setCurrentBlock("stats_row");
$tmpl->setVariable($totals);
$tmpl->parseCurrentBlock();

$tmpl->show();
?>
