<?php
header("Content-type: text/plain");
require_once("conf.php");

// Check for convert
$convert = explode(" ",CONVERT);
$convert = $convert[0];
echo "Checking for convert ($convert) ... ";
if(is_executable($convert)) {
    echo "OK\n\n";
} else {
    echo "FAILED\n\n";
    exit;
}

// Check for identify
$identify = explode(" ",IDENTIFY);
$identify = $identify[0];
echo "Checking for identify ($identify) ... ";
if(is_executable($identify)) {
    echo "OK\n\n";
} else {
    echo "FAILED\n\n";
    exit;
}

// Check for directory permissions
foreach(array(IMAGE_DIR,THUMB_DIR,CACHE_DIR) as $x) {
    echo "Checking permissions on $x ... ";
    if(is_writable($x)) {
        echo "OK\n\n";
    } else {
        echo "FAIL - COULDN'T WRITE\n\n";
        exit;
    }
}

// Check for sqlite availability
echo "Checking for sqlite support in PHP ... ";
if(is_callable("sqlite_open")) {
    echo "OK\n\n";
} else {
    echo "FAILED\n\n";
    exit;
}
// Check for sqlite db writability
echo "Checking for sqlite db writeablility ... ";
if(is_writable(dirname(DB))) {
    echo "OK\n\n";
} else {
    echo "FAILED\n\n";
    exit;
}

// Check that the database file doesn't already exist!
echo "Checking for presence of database ... ";
if(file_exists(DB) && filesize(DB)) {
    echo "FAILED - DATABASE FILE EXISTS\n\n";
    exit;
} else {
    echo "OK - database doesn't exist yet\n\n";
}

// Load database
echo "Installing database ... ";
$db = sqlite_open(DB);
$schema = array(
    "create table bans(ip primary key, date integer, tripcode, reason)",
    "create table categories(id integer primary key,category unique,abbr unique,description,sort)",
    "create table images(id integer primary key,parent int,name,tripcode,title,file,type,animated,size,resolution,keywords,category,comment,date,ip,mtime,views integer default 0, sort int,hash,deleted)",
    "create table tmp(id integer primary key,parent int,name,tripcode,title,file,type,animated,size,resolution,keywords,category,comment,date,ip,mtime,views integer default 0, sort int,hash,deleted)",
    "create view v_categorized as select i.id,i.parent,i.name,i.tripcode,i.title,i.file,i.type,i.animated,i.size,i.resolution,i.keywords,i.comment,i.date,i.ip,i.mtime,i.views,x.category from images i join (select id,category from images where parent is null) as x where i.parent=x.id union select id,parent,name,tripcode,title,file,type,animated,size,resolution,keywords,comment,date,ip,mtime,views,category from images where parent is null"
);
foreach ($schema as $line) {
    if(!sqlite_exec($db,$line)) {
        echo "\n\nOOPS. Error attempting '$line'. You have some clean up to do";
        exit;
    }
}
echo "OK!!!\n\n";
echo "--> All systems go. You should now delete this file (" . __FILE__ . ")\n";
?>
