// Add an eventListener to browsers that can do it somehow.
// Originally by the amazing Scott Andrew.
function addEvent(obj, evType, fn){
  if (obj.addEventListener){
    obj.addEventListener(evType, fn, true);
    return true;
  } else if (obj.attachEvent){
	var r = obj.attachEvent("on"+evType, fn);
    return r;
  } else {
	return false;
  }
}

addEvent(window,'load',tripcodeSet);
addEvent(window,'load',collapseOrExpand);
addEvent(window,'load',hiliter);

var myOptions = 'hotkeys,scrollbars=yes,width=500,height=500';

function pop(what) {
	// Using '_blank' for name makes popup separate across invocations
	// ie 2 separate sites won't fight for the same popup, and even within
	// a site, two separate actions won't target the same
	window.name=location.href;
	popUpWin = window.open(what,'_blank',myOptions);
}

function tripcodeSet()
{
	if(me = document.getElementById("tripcode")) {
		if(tripcode = getCookie("tripcode")) {
			me.value = tripcode.replace("+"," "); // Bad interplay between JS/PHP
		}
	}
	if(me = document.getElementById("verify")) {
		me.value = "";
	}
}

function getCookie(name)
{
	var cookie = document.cookie;
	var key = document.cookie.indexOf(name);
	if (key == -1 || !name) {
		return false;
	}
	var start = key+name.length+1;
	var end = document.cookie.indexOf(';',key);
	if (end == -1) {
		end=document.cookie.length;
	}
	return unescape(document.cookie.substring(start,end));
}

function checkPost()
{
	// Name is required
	if (!document.getElementById('name').value) {
		alert('A name is required');
		document.getElementById('name').focus();
		return false;
	}

	if(document.getElementById('title')) {

		// Category is required if thread starter
		me = document.forms["post"];
		count = 0;
		for(i=0;i<me.elements.length;i++) {
			if(me.elements[i].name.indexOf('categories') == 0 &&
				me.elements[i].checked) {
				count++;
			}
		}
		if(count<1) {
			alert('At least one category is required');
			return false;
		}
	}

	// If verification enabled, it is required
	if(me = document.getElementById("verify")) {
		if(!me.value) {
			alert("Please enter a verification as shown");
			me.focus();
			return false;
		}
	}

	// Really should enter a tripcode
	if(!document.getElementById("tripcode").value) {
		return confirm("Are you sure you want to submit without a tripcode? You won't be able to delete your comment without one.");
	}

	return true;
	
}

function collapse(id)
{
	document.getElementById(id).style.display = 'none';
	document.getElementById("collapser_" + id).style.display = 'none';
	document.getElementById("expander_" + id).style.display = 'inline';
	document.getElementById("filler_" + id).style.display = 'block';
}
function expand(id)
{
	document.getElementById(id).style.display = 'block';
	document.getElementById("collapser_" + id).style.display = 'inline';
	document.getElementById("expander_" + id).style.display = 'none';
	document.getElementById("filler_" + id).style.display = 'none';
}
function all(what)
{
	var msg;
	var date = new Date();
	date.setTime(date.getTime()+(24*60*60*1000));
	cookiestring = "; expires=" + date.toGMTString() + "; path=/";
	deletestring = "; expires=Thu, 01-Jan-70 00:00:01 GMT; path=/";
	if(what == "expand") {
		document.cookie = "expand=1" + deletestring;
	} else {
		document.cookie = "expand=0" + cookiestring;
	}


	cblocks = document.getElementsByTagName("blockquote");
	for(var i = 0; i<cblocks.length;i++) {
		thisid = cblocks[i].id;
		if(thisid.indexOf("cblock") == 0 && document.getElementById("collapser_" + thisid)) {
			if(what == "collapse") {
				collapse(thisid);
			} else if (what == "expand") {
				expand(thisid);
			}
		}
	}
}
function collapseOrExpand()
{
	var expand = true;
	if(what = getCookie("expand")) {
		if(what == "0") {
			expand = false;
		}
	}
	if(expand) {
		all('expand');
	} else {
		all('collapse');
	}
}

function fileCheck() {
	filename=document.forms["post"]["file_upload"].value;
	if(me = document.getElementById("thread")) {
		if(filename.length-filename.indexOf("zip") == 3) {
			me.style.display = 'inline';
		} else {
			me.style.display = 'none';
		}
	}
}
function hilite(which) {
	if(me = document.getElementById("i" + which)) {
		me.style.background = '#ffd';
		location.href = "#i" + which;
	} else {
		location.href = which;
	}
}
function hiliter() {
	var parts = location.href.split("#");
	if(me = document.getElementById(parts[1])) {
		me.style.background = '#ffd';
	}
}
